<script lang="ts">
import { defineComponent } from "vue";
import { useCookies } from "vue3-cookies";
import { PositionType } from "./ChordPosition.vue";

export default defineComponent({
  setup() {
    const { cookies } = useCookies();
    return { cookies };
  },
  data() {
    const countdown = 0;
    return { countdown };
  },
  mounted() {
    const setCountdown = (): void => {
      const cookie = this.cookies.get("ukordle");
      if (cookie) {
        // work how long left until the next day?
        const secondsInDay = 60 * 60 * 24;
        const cookie24HoursLater =
          Math.floor(cookie.epoch / 1000) + secondsInDay;
        const secondsTomorrow =
          cookie24HoursLater - (cookie24HoursLater % secondsInDay);
        const secondsNow = Math.floor(Date.now() / 1000);
        const diff = secondsTomorrow - secondsNow;
        this.countdown = diff > 0 ? diff : 0;
      }
    };

    setCountdown();
    setInterval(setCountdown, 1000);
  },
  props: {
    guessedIdx: { type: Number, required: true },
    noGuessesLeft: { type: Boolean, required: true },
  },
  methods: {
    copyToClipBoard() {
      const cookie = this.cookies.get("ukordle");
      // magic day when published!
      const day = Math.floor(cookie.epoch / (1000 * 60 * 60 * 24)) - 19055;
      let share =
        "Ukordle " +
        day +
        " " +
        (this.guessedIdx >= 0 ? this.guessedIdx + 1 : "6") +
        "/5\n";
      cookie.guesses.forEach((guess) => {
        share += "\n";
        for (let i = 0; i < 4; ++i) {
          let thisGuess = "⬜";
          guess.forEach((fret) => {
            if (fret[i + 1] === PositionType.GuessClose) {
              thisGuess = "🟨";
            } else if (fret[i + 1] === PositionType.GuessCorrect) {
              thisGuess = "🟩";
            }
          });

          share += thisGuess;
        }
      });
      navigator.clipboard.writeText(share);
      this.$emit("flash", "Copied results to clipboard");
    },
  },
  computed: {
    countdownStr() {
      const hours = Math.floor(this.countdown / (60 * 60));
      const minutesAndSeconds = this.countdown - hours * 60 * 60;
      const minutes = Math.floor(minutesAndSeconds / 60);
      const seconds = minutesAndSeconds - minutes * 60;
      return (
        (hours < 10 ? "0" + hours : hours) +
        ":" +
        (minutes < 10 ? "0" + minutes : minutes) +
        ":" +
        (seconds < 10 ? "0" + seconds : seconds)
      );
    },
    played() {
      const cookie = this.cookies.get("ukordle");
      return cookie ? cookie.played : 0;
    },
    wonPercent() {
      const cookie = this.cookies.get("ukordle");
      return cookie ? Math.round((cookie.won / cookie.played) * 100) : 0;
    },
    currentStreak() {
      const cookie = this.cookies.get("ukordle");
      return cookie ? cookie.currentStreak : 0;
    },
    maxStreak() {
      const cookie = this.cookies.get("ukordle");
      return cookie ? cookie.maxStreak : 0;
    },
    stats() {
      const cookie = this.cookies.get("ukordle");
      if (!cookie) {
        return null;
      }
      let max = 0;
      cookie.stats.forEach((stat) => {
        if (stat > max) {
          max = stat;
        }
      });

      const ret = [];
      cookie.stats.forEach((count) => {
        let percent = Math.round((count / max) * 100);
        ret.push({
          count,
          percent: percent > 5 ? percent : 5,
        });
      });
      return ret;
    },
  },
  emits: ["onClose"],
});
</script>

<template>
  <div class="outer_container">
    <div class="container">
      <i class="close fa-solid fa-xmark fa-lg" @click="$emit('onClose')"></i>
      <div class="content">
        <h1 class="title">Statistics</h1>
        <div class="statistics">
          <div class="stat">
            <div class="value">{{ played }}</div>
            <div class="label">Played</div>
          </div>
          <div class="stat">
            <div class="value">{{ wonPercent }}</div>
            <div class="label">Win %</div>
          </div>
          <div class="stat">
            <div class="value">{{ currentStreak }}</div>
            <div class="label">Current Streak</div>
          </div>
          <div class="stat">
            <div class="value">{{ maxStreak }}</div>
            <div class="label">Max Streak</div>
          </div>
        </div>
        <h1 class="title">Guess Distribution</h1>
        <div class="distributions">
          <div v-if="!stats" style="text-align: center">No Data</div>
          <template v-else>
            <div
              v-for="(stat, guessed_in) in stats"
              :key="guessed_in"
              class="distribution"
            >
              <div class="guess_in">
                {{ guessed_in + 1 }}
              </div>
              <div class="graph">
                <div
                  :class="
                    guessed_in === guessedIdx ? 'graph_guess' : 'graph_bar'
                  "
                  :style="{ width: stat.percent + '%' }"
                >
                  <div class="guess_count">{{ stat.count }}</div>
                </div>
              </div>
            </div>
          </template>
        </div>
        <div v-if="guessedIdx >= 0 || noGuessesLeft" class="footer">
          <div class="countdown">
            <h1>Next UKORDLE</h1>
            <div class="stat">
              <div class="value">{{ countdownStr }}</div>
            </div>
          </div>
          <div class="share">
            <button class="share_button" @click="copyToClipBoard">
              Share&nbsp;
              <i style="color: white" class="fa-solid fa-share-nodes"></i>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<style scoped>
.close {
  float: right;
  cursor: pointer;
}
.guess_count {
  font-weight: bold;
  color: white;
}

.distributions {
  padding-bottom: 10px;
  width: 80%;
}

.distribution {
  width: 100%;
  height: 20px;
  display: flex;
  align-items: center;
  padding-bottom: 4px;
  font-size: 14px;
  line-height: 20px;
}

.graph_bar {
  justify-content: flex-end;
  padding-right: 8px;
  position: relative;
  background-color: #787c7e;
  display: flex;
}

.graph_guess {
  justify-content: flex-end;
  padding-right: 8px;
  position: relative;
  background-color: var(--correct);
  display: flex;
}

.graph {
  width: 100%;
  height: 100%;
  padding-left: 4px;
}

.statistics {
  display: flex;
  padding-bottom: 10px;
}

.stat {
  flex: 1;
}

.value {
  font-size: 36px;
  font-weight: 400;
  display: flex;
  align-items: center;
  justify-content: center;
  text-align: center;
  letter-spacing: 0.05em;
  font-variant-numeric: proportional-nums;
}

.label {
  font-size: 12px;
  display: flex;
  align-items: center;
  justify-content: center;
  text-align: center;
}

.footer {
  display: flex;
  width: 100%;
}

.countdown {
  border-right: 1px solid var(--primary);
  padding-right: 12px;
  width: 50%;
  min-width: 12em;
}

.share {
  display: flex;
  justify-content: center;
  align-items: center;
  padding-left: 12px;
  width: 50%;
}

.share_button {
  background-color: var(--correct);
  color: white;
  font-family: inherit;
  font-weight: bold;
  border-radius: 4px;
  cursor: pointer;
  border: none;
  user-select: none;
  display: flex;
  justify-content: center;
  align-items: center;
  text-transform: uppercase;
  width: 80%;
  font-size: 20px;
  height: 52px;
}

h1 {
  font-weight: 700;
  font-size: 16px;
  letter-spacing: 0.5px;
  text-transform: uppercase;
  text-align: center;
  margin-bottom: 10px;
}

.content {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}

.outer_container {
  width: 468px;
}

.container {
  margin: 1em;
  font-size: 14px;
  font-family: "Clear Sans", "Helvetica Neue", Arial, sans-serif;
  border-radius: 8px;
  border: var(--popup-border);
  background: var(--bg);
  box-shadow: 0 4px 23px 0 rgb(0 0 0 / 20%);
  max-height: 90%;
  overflow-y: auto;
  box-sizing: border-box;
  padding: 16px;
}
</style>
